﻿namespace VersionBuilder:
	import MetaSharp.Transformation;
	import MetaSharp.Transformation.Lang.Ast;
	import System.CodeDom;
	import System.Linq;
	import System.Reflection;

	grammar VersionParser:

		Main =  Number Dot Number Dot Number Dot Number -> {
			string version = Parser.Stringify(match);
			Unit unit = new Unit();
			unit.AssemblyCustomAttributes.Add(
				new AttributeDeclaration(
					new TypeReference(typeof(AssemblyVersionAttribute)),
					new AttributeArgument(new PrimitiveExpression(version))));
			unit.AssemblyCustomAttributes.Add(
				new AttributeDeclaration(
					new TypeReference(typeof(AssemblyFileVersionAttribute)),
					new AttributeArgument(new PrimitiveExpression(version))));

			return unit;
		}

		Number = '0'..'9'+;
		Dot = '.';

	end
end