﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace MetaSharp.Build
{
	public class DefaultFileService : IFileService
	{
		string IFileService.ReadAllText(string path)
		{
			return File.ReadAllText(path);
		}

		DateTime IFileService.GetLastWriteTimeUtc(string path)
		{
			return File.GetLastWriteTimeUtc(path);
		}

		void IFileService.WriteAllText(string path, string contents, Encoding encoding)
		{
			File.WriteAllText(path, contents, encoding);
		}

		void IFileService.CreateDirectory(string path)
		{
			Directory.CreateDirectory(path);
		}

		bool IFileService.Exists(string path)
		{
			return Directory.Exists(path) || File.Exists(path);
		}

		Stream IFileService.Open(string path, FileMode mode, FileAccess access, FileShare share)
		{
			return File.Open(path, mode, access, share);
		}

		void IFileService.Delete(string path)
		{
			if (File.Exists(path))
				File.Delete(path);
			else if (Directory.Exists(path))
				Directory.Delete(path, true);
		}

		void IFileService.WriteAllBytes(string path, byte[] bytes)
		{
			File.WriteAllBytes(path, bytes);
		}


		void IFileService.Move(string sourceFileName, string destFileName)
		{
			File.Move(sourceFileName, destFileName);
		}
	}
}
