﻿namespace MetaSharp.Build
{
	using System;
	using System.Collections.Generic;
	using System.Linq;
	using System.Runtime.Serialization;

	[DataContract(Namespace = GeneratedFileManager.DataContractNamespace)]
	[KnownType(typeof(GeneratedFile))]
	internal class GeneratedFiles
	{
		[DataMember]
		public DateTime? LastUpdateOfGrammarTransformer
		{
			get; 
			set;
		}

		[DataMember]
		public List<GeneratedFile> Files
		{
			get;
			set;
		}

		public GeneratedFiles()
		{
			Files = new List<GeneratedFile>();
		}

		internal void AddOrUpdate(GeneratedFile generatedFile)
		{
			var generatedFileItem = Files.FirstOrDefault(i => String.Compare(i.SourceFilename, generatedFile.SourceFilename, StringComparison.OrdinalIgnoreCase) == 0);

			if (generatedFileItem == null)
			{
				Files.Add(generatedFile);
			}
			else
			{
				generatedFileItem.SourceLastModificationDate = generatedFile.SourceLastModificationDate;
				generatedFileItem.TargetFilename = generatedFile.TargetFilename;
				generatedFileItem.TargetCreationDate = generatedFile.TargetCreationDate;
			}
		}
	}
}
