﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MetaSharp.Transformation;

namespace MetaSharp.Build.Grammar
{
	public interface IGrammarBuildProvider
	{
		INode GetResult(string documentPath);
		//IEnumerable<INode> GetResults(string projectPath);
		//IEnumerable<RuleMetadata> GetMetadata(string documentPath);
		//IEnumerable<Error> GetErrors(string documentPath);

		string GetText(string documentPath);
		string GetDocumentProject(string documentPath);

		event Action<string, CompileResult> BuildComplete;
		event Action<string> Closing;
		event Action<string, string> Renamed;

		void Add(string projectPath, string documentPath, Func<string> code);
		void Remove(string documentPath);
		void Rename(string oldDocumentPath, string documentPath);

		void Update(string documentPath, Func<string> code);

	}

	public interface IDslBuildProvider : IGrammarBuildProvider
	{
		IImmutableArray<string> GetTransformTypes(string documentPath);
		void SetTransformType(string documentPath, string type);
	}
}
