﻿namespace MetaSharp.Build
{
	using MetaSharp.Build.Resources;
	using Microsoft.Build.Framework;
	using Microsoft.Build.Utilities;

	public class MetaSharpCleanTask : Task
	{
		private IFileService fileService;
		public MetaSharpCleanTask()
			: this(new DefaultFileService())
		{
		}

		public MetaSharpCleanTask(IFileService fileService)
		{
			this.fileService = fileService;
		}

		/// <summary>
		/// Gets or sets the path at which to put intermediate files.
		/// </summary>
		[Required]
		public ITaskItem IntermediateOutputPath { get; set; }

		public override bool Execute()
		{
			using (var generatedFileManager = new GeneratedFileManager(
				this.fileService,
				Strings.MetaSharp,
				this.BuildEngine3.ProjectFileOfTaskNode,
				this.IntermediateOutputPath.ItemSpec,
				"dummy",
				this.Log,
				true))
			{
			}

			return true;
		}
	}
}
