﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MetaSharp.Build;
using System.IO;
using Microsoft.Cci;
using System.Reflection;

namespace MetaSharp.Integration.VisualStudio.Grammar
{
	class CciDynamicCompiler : IDynamicCompiler
	{
		private IFileService fileService;
		public CciDynamicCompiler(IFileService fileService)
		{
			this.fileService = fileService;
		}

		public Assembly DynamicLoad(string assemblyPath, string pdbPath)
		{
			using (var host = new PeReader.DefaultHost())
			{
				using (var pdbStream = fileService.Open(pdbPath, System.IO.FileMode.OpenOrCreate, System.IO.FileAccess.Read, System.IO.FileShare.None))
				{
					var pdbreader = new PdbReader(pdbStream, host);
					var name = Path.GetFileNameWithoutExtension(assemblyPath);
					var loaded = host.LoadAssembly(new AssemblyIdentity(host.NameTable.GetNameFor(name), null, new Version(), null, assemblyPath));

					var dynamicLoader = new Microsoft.Cci.ReflectionEmitter.DynamicLoader(pdbreader, pdbreader);
					return dynamicLoader.Load(loaded);
				}
			}
		}
	}
}
