﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Utilities;
using Microsoft.VisualStudio.Text.Tagging;
using Microsoft.VisualStudio.Text;
using MetaSharp.Build.Grammar;
using MetaSharp.Build;

namespace MetaSharp.Integration.VisualStudio.Grammar
{
	[Export(typeof(ITaggerProvider))]
	[ContentType(MetaSharpFileTypeDefinitions.DslFileExtensionContentType)]
	[TagType(typeof(IErrorTag))]
	internal sealed class DslErrorTaggerProvider : ITaggerProvider
	{
		[Import]
		private IDslBuildProvider buildProvider = null;

		[Import]
		private IActionQueue queue = null;

		public ITagger<T> CreateTagger<T>(ITextBuffer buffer) where T : ITag
		{
			return new MetaSharpErrorTagger(buffer, queue, buildProvider) as ITagger<T>;
		}
	}
}
