﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Utilities;
using Microsoft.VisualStudio.Text.Tagging;
using Microsoft.VisualStudio.Text;
using MetaSharp.Build.Grammar;
using MetaSharp.Build;

namespace MetaSharp.Integration.VisualStudio.Grammar
{
	[Export(typeof(ITaggerProvider))]
	[ContentType(MetaSharpFileTypeDefinitions.GrammarFileExtensionContentType)]
	[TagType(typeof(MetaSharpMetadataTag))]
	internal sealed class GrammarMetadataTaggerProvider : ITaggerProvider
	{
#pragma warning disable 0649
		[Import]
		public IGrammarBuildProvider buildProvider;

		[Import]
		public IActionQueue queue;
#pragma warning restore 0649

		public ITagger<T> CreateTagger<T>(ITextBuffer buffer) where T : ITag
		{
			return new MetaSharpMetadataTagger(buffer, queue, buildProvider) as ITagger<T>;
		}
	}
}
