﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Utilities;

namespace MetaSharp.Integration.VisualStudio.Grammar
{
	public class MetaSharpFileTypeDefinitions
	{
		public const string GrammarContentTypeName = "Grammar";
		public const string GrammarFileExtension = ".g";
		public const string GrammarFileExtensionContentType = "grammar";
		public const string DslContentTypeName = "MetaSharpDSL";
		public const string DslFileExtension = ".mdsl";
		public const string DslFileExtensionContentType = "metasharpdsl";

		[Export]
		[Name(GrammarContentTypeName)]
		[BaseDefinition("code")]
		internal static ContentTypeDefinition GrammarContentType = null;

		[Export]
		[FileExtension(GrammarFileExtension)]
		[ContentType(GrammarFileExtensionContentType)]
		internal static FileExtensionToContentTypeDefinition GrammarFileType = null;

		[Export]
		[Name(DslContentTypeName)]
		[BaseDefinition("code")]
		internal static ContentTypeDefinition MetaSharpDslContentType = null;

		[Export]
		[FileExtension(DslFileExtension)]
		[ContentType(DslFileExtensionContentType)]
		internal static FileExtensionToContentTypeDefinition MetaSharpDslFileType = null;
	}
}
