﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using Microsoft.VisualStudio.Text;
using Microsoft.VisualStudio.Text.Classification;
using Microsoft.VisualStudio.Text.Editor;
using Microsoft.VisualStudio.Text.Tagging;
using Microsoft.VisualStudio.Utilities;
using MetaSharp.Transformation.Lang;

namespace MetaSharp.Integration.VisualStudio.Grammar
{
	[Export(typeof(ITaggerProvider))]
	[ContentType(MetaSharpFileTypeDefinitions.GrammarFileExtensionContentType)]
	[ContentType(MetaSharpFileTypeDefinitions.DslFileExtensionContentType)]
	[TagType(typeof(ClassificationTag))]
	internal sealed class MetaSharpMetadataClassifierProvider : ITaggerProvider
	{
		[Import]
		internal IClassificationTypeRegistryService classificationTypeRegistry = null;

		[Import]
		internal IBufferTagAggregatorFactoryService aggregatorFactory = null;

		public ITagger<T> CreateTagger<T>(ITextBuffer buffer) where T : ITag
		{
			var tagAggregator = aggregatorFactory.CreateTagAggregator<MetaSharpMetadataTag>(buffer);
			return new MetaSharpMetadataClassifier(
				buffer,
				tagAggregator,
				classificationTypeRegistry) as ITagger<T>;
		}
	}
}
