﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MetaSharp.Integration.VisualStudio.Grammar
{
	public abstract class Tag
	{
		public int Start { get; private set; }
		public int End { get; private set; }
		public Tag(int start, int end)
		{
			Start = start;
			End = end;
		}

		public override bool Equals(object obj)
		{
			var tag = obj as Tag;
			return tag != null &&
				this.Start == tag.Start &&
				this.End == tag.End;
		}

		public override int GetHashCode()
		{
			return this.Start.GetHashCode() ^ this.End.GetHashCode();
		}
	}
}
