﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit;
using System.Resources;
using MetaSharp.Transformation.Properties;
using NSubstitute;

namespace MetaSharp.Transformation.Tests.Patterns
{
	public class AnyTests
	{
		[Fact]
		public void ReadsCharacterSuccessfully()
		{
			var result = Pattern.Parse("a", Pattern.Any());
			Assert.Equal('a', Node.Unwrap(result));
		}

		[Fact]
		public void ReadsNodeSuccessfully()
		{
			var expected = Substitute.For<INode>();
			var actual = Pattern.Transform(expected, Pattern.Any());
			Assert.Equal(expected, actual);
		}

		[Fact]
		public void FailsToReadEmptyStream()
		{
			var result = Pattern.Parse("", Pattern.Any());
			Assert.IsType<Null>(result);
		}

		[Fact]
		public void ReadsExactlyOneInputElement()
		{
			var result = Pattern.Parse("abc", Pattern.Any());
			Assert.IsType<Fail>(result);
		}
	}
}
