﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit;
using MetaSharp.Transformation.Properties;

namespace MetaSharp.Transformation.Tests.Patterns
{
	public class DefaultTests
	{
		[Fact]
		public void ReadsEmptyInput()
		{
			var result = Pattern.Parse("", Pattern.Default());
			Assert.Null(Node.Unwrap(result));
		}

		[Fact]
		public void ReadsNoInput()
		{
			var result = Pattern.Parse("a", Pattern.Default());
			Assert.IsType<Fail>(result);
		}

		[Fact]
		public void ReadsNoInputButProjects()
		{
			var result = (Nodes)Pattern.Parse("ab", Pattern.And(Pattern.Any(), Pattern.Default(), Pattern.Any()));
			Assert.Equal('a', Node.Unwrap(result[0]));
			Assert.Null(Node.Unwrap(result[1]));
			Assert.Equal('b', Node.Unwrap(result[2]));
		}
	}
}
