﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit;

namespace MetaSharp.Transformation.Tests.Patterns
{
	public class OrTests
	{
		[Fact]
		public void ReadsZeroPatternFails()
		{
			var result = Pattern.Parse("", Pattern.Or());
			Assert.IsType<Null>(result);
		}

		[Fact]
		public void ReadsOnePatternSuccessfully()
		{
			var result = Pattern.Parse("a", Pattern.Or(Pattern.Any()));
			Assert.Equal('a', Node.Unwrap(result));
		}

		[Fact]
		public void ReadsFirstPatternsSuccessfully()
		{
			var result = Pattern.Parse("a", Pattern.Or(Pattern.Value('a'), Pattern.Value('b')));
			Assert.Equal('a', Node.Unwrap(result));
		}

		[Fact]
		public void ReadsSecondPatternSuccessfully()
		{
			var result = Pattern.Parse("b", Pattern.Or(Pattern.Value('a'), Pattern.Value('b')));
			Assert.Equal('b', Node.Unwrap(result));
		}

		[Fact]
		public void DoesNotReadTooManyPatterns()
		{
			var result = Pattern.Parse("ab", Pattern.Or(Pattern.Any()));
			Assert.IsType<Fail>(result);
		}
	}
}
