﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Xunit;

namespace MetaSharp.Transformation.Tests.Patterns
{
	public class ProjectionTests
	{
		[Fact]
		public void ProjectsSuccessfully()
		{
			var result = Pattern.Parse("a", Pattern.Projection(Pattern.Any(), s => Node.Wrap('z')));
			Assert.Equal('z', Node.Unwrap(result));
		}

		[Fact]
		public void DoesNotProjectWhenFails()
		{
			var projected = false;
			var actual = Pattern.Parse("a", Pattern.Projection(Pattern.Not(Pattern.Any()), s => { return Node.Wrap(projected = true); }));
			Assert.IsType<Fail>(actual);
			Assert.False(projected);
		}
	}
}
