﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MetaSharp.Transformation
{
	public enum ErrorLocation
	{
		Span,
		After
	}

	public enum ErrorSeverity
	{
		Error,
		Warning,
		Info
	}

	public class Error : IHaveSourceSpan
	{
		public SourceSpan Span { get; private set; }
		public ErrorSeverity Severity { get; private set; }
		public string Message { get; private set; }

		public Error(SourceSpan span, ErrorSeverity severity, string message)
		{
			this.Span = span;
			this.Severity = severity;
			this.Message = message;
		}
	}
}
