﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MetaSharp.Transformation
{
	public interface IImmutableArray<T> : IEnumerable<T>
	{
		T this[int x] { get; }
		int Length { get; }
		void CopyTo(int index, T[] array, int arrayIndex, int count);
	}

	public class ArrayList<T> : List<T>, IImmutableArray<T>
	{
		public ArrayList() { }
		public ArrayList(IEnumerable<T> items)
			: base(items)
		{ }

		public int Length
		{
			get { return this.Count; }
		}
	}
}
