﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Dynamic;
using System.Reflection;
using System.Globalization;
using System.Diagnostics;

namespace MetaSharp.Transformation
{
	public interface INode
	{
	}

	public class Nodes : Nodes<INode>
	{
		public Nodes()
			: base()
		{
		}
		public Nodes(params INode[] items)
			: this((IEnumerable<INode>)items)
		{ }

		public Nodes(IEnumerable<INode> items)
			: base(items)
		{
		}
	}

	public class Nodes<T> : List<T>, INode
	// TODO: Add this constraint once we're free of the CodeDom...
	// where T : INode
	{
		public Nodes()
			: base()
		{
		}
		public Nodes(params T[] items)
			: this((IEnumerable<T>)items)
		{ }

		public Nodes(IEnumerable<T> items)
			: base(items)
		{
		}
	}

	public class Node : INode
	{
		private object value;
		protected Node(object value)
		{
			this.value = value;
		}

		public object Value
		{
			get { return this.value; }
		}

		public static object Unwrap(object node)
		{
			Node tok = node as Node;
			if (tok != null)
				return tok.Value;

			return node;
		}

		public static INode Wrap(object node)
		{
			INode n = node as INode;
			if (n == null)
				n = new Node(node);

			return n;
		}

		public override string ToString()
		{
			return string.Format(CultureInfo.CurrentCulture, "Node({0})", this.value);
		}
	}
}
