﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.CodeDom;

namespace MetaSharp.Transformation.Lang.Ast
{
	public class TypeReference : CodeTypeReference, INode
	{
		public TypeReference()
			: base()
		{ }

		public TypeReference(TypeParameter typeParameter)
			: base(typeParameter)
		{ }

		public TypeReference(string typeName)
			: base(typeName)
		{ }

		public TypeReference(Type type)
			: base(type)
		{ }

		public TypeReference(TypeReference arrayType, int rank)
			: base(arrayType, rank)
		{ }

		public TypeReference(string typeName, CodeTypeReferenceOptions codeTypeReferenceOption)
			: base(typeName, codeTypeReferenceOption)
		{ }

		public TypeReference(string baseType, int rank)
			: base(baseType, rank)
		{ }

		public TypeReference(string typeName, params TypeReference[] typeArguments)
			: base(typeName, typeArguments)
		{ }

		public TypeReference(Type type, CodeTypeReferenceOptions codeTypeReferenceOption)
			: base(type, codeTypeReferenceOption)
		{ }
	}
}
