﻿//-----------------------------------------------------------------------
// <copyright company="MetaSharp">
//     Copyright (c) MetaSharp. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------
namespace MetaSharp.Transformation
{
	using System;
	using System.Linq;
	using System.Collections.Generic;
	using System.Collections;

	public sealed class NodeStream : StreamBase
	{
		public NodeStream(object node)
			: this(node as IEnumerable ?? new[] { node })
		{ }

		public NodeStream(params object[] nodes)
			: this((IEnumerable)nodes)
		{ }

		public NodeStream(IEnumerable nodes)
			: base(new ArrayPosition(null, nodes))
		{
		}
	}
}
