﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace MetaSharp.Transformation
{
	public class PropertyPosition : Position
	{
		private INode instance;
		private PropertyInfo property;
		private ValuePosition next;

		public PropertyPosition(Position parent, object instance, PropertyInfo property)
			: base(parent)
		{
			this.instance = Node.Wrap(instance);
			this.property = property;
		}

		public PropertyInfo Property
		{
			get { return this.property; }
		}

		public override INode Current
		{
			get { return this.instance; }
		}

		public override Position Next()
		{
			return this.next ?? (this.next = new ValuePosition(this, property.GetValue(Node.Unwrap(instance), null)));
		}

		protected override void BuildString(StringBuilder builder)
		{
			builder.Append("/");
			builder.Append(this.property.Name);
		}
	}
}
