﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MetaSharp.Transformation
{
	public abstract class StreamBase : IStream
	{
		private Position position;
		private StreamScope scope = new StreamScope();

		protected StreamBase(Position position)
		{
			this.position = position;
		}

		public bool MoveNext()
		{
			if (!this.position.IsEnd)
				this.position = this.position.Next();

			return !this.position.IsEnd;
		}

		public bool MoveInto()
		{
			this.position = this.position.Into();
			return this.position != null;
		}

		public bool MoveInto(string propertyName)
		{
			this.position = this.position.Into(propertyName);
			return this.position != null;
		}

		public bool StepTo(string name)
		{
			var value = this.scope.Current.Variables[name];
			this.position = this.position.To(name, value);
			return this.position != null;
		}

		public Position Position
		{
			get { return this.position; }
			set { this.position = value; }
		}

		public INode Current
		{
			get { return this.position.Current; }
		}

		public StreamScope Scope
		{
			get { return this.scope; }
		}
	}
}
