﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MetaSharp.Transformation
{
	public class ValuePosition : Position
	{
		private INode value;
		public ValuePosition(Position parent, object value)
			: base(parent)
		{
			this.value = Node.Wrap(value);
		}

		public override INode Current
		{
			get { return this.value; }
		}

		protected override void BuildString(StringBuilder builder)
		{
			builder.Append("/{");
			builder.Append(value != null ? value.ToString() : "null");
			builder.Append("}");
		}
	}
}
